<?php

namespace Ulmus\Annotation\Property;

class Relation implements \Ulmus\Annotation\Annotation {

    public string $type;

    public /*stringable*/ $key;

    public /* callable */ $generateKey;

    public /*stringable*/ $foreignKey;

    public array $foreignKeys;

    public string $bridge;

    public /*stringable*/ $bridgeKey;

    public /*stringable*/ $bridgeForeignKey;

    public string $entity;

    public string $join;

    public string $function = "loadAll";

    public function __construct(string $type = null)
    {
        if ( $type !== null ) {
            $this->type = $type;
        }
    }

    public function entity() {
        try {
            $e = $this->entity;
        } catch (\Throwable $ex) {
            throw new \Exception("Your @Relation annotation seems to be missing an `entity` entry.");
        }

        return new $e();
    }

    public function bridge() {
        $e = $this->bridge;

        return new $e();
    }

    public function normalizeType() : string
    {
        return strtolower(str_replace(['-', '_', ' '], '', $this->type));
    }

    public function isOneToOne() : bool
    {
        return $this->normalizeType() === 'onetoone';
    }

    public function isOneToMany() : bool
    {
        return $this->normalizeType() === 'onetomany';
    }

    public function isManyToMany() : bool
    {
        return $this->normalizeType() === 'manytomany';
    }

    public function hasBridge() : bool
    {
        return isset($this->bridge);
    }
}
